#include <sys/param.h>
#include <sys/buf.h>

#include <sys/extypes.h>
#include <sys/socket.h>
#include <sys/exreg.h>
#include <sys/init.h>
#include <sys/swap.h>
#include <sys/exos.h>

#ifdef PEGASUS
#include "config.h"
#endif
extern	struct exctrl ex_db;
extern	struct rmsg_area *rmsgarea;
extern	struct wmsg_area *wmsgarea;

/***************************************************************************/
/* Set PORTADDR for YOUR system !!!                                        */
/***************************************************************************/

/* base i/o address of excelan on multibus */
#define	PORTADDR	0x8000

#undef	DEBUG

/*
 * ex_getbuf:
 *	- get a buffer from the buffer cache which does not cross
 *	  a segment boundary - this is presumed to be in the multibus
 *	  address space
 *	- if we get a buffer which crosses a segment boundary, recurse
 *	  until we get a good one
 */
struct buf *
ex_getbuf()
{
	register struct buf *nextbp, *bp;
	register caddr_t p;
	struct buf *geteblk();

	bp = geteblk();
	clear(bp->b_un.b_addr, BSIZE);
	return bp;
}

exinit()
{
	ex_db.ex_port = (Ushort) PORTADDR;
	ex_db.ex_imsg = ex_getbuf()->b_un.b_addr;
	rmsgarea = (struct rmsg_area *) ex_getbuf()->b_un.b_addr;
	wmsgarea = (struct wmsg_area *) ex_getbuf()->b_un.b_addr;
#ifdef	DEBUG
printf("rmsg area at %x (physical=%x%x)\n", rmsgarea, 
	(int)( (vtop(rmsgarea) >> 16) & 0xFFFF),
	(int)( vtop(rmsgarea) & 0xFFFF));
printf("wmsg area at %x (physical=%x%x)\n", wmsgarea,
	(int)( (vtop(wmsgarea) >> 16) & 0xFFFF),
	(int)( vtop(wmsgarea) & 0xFFFF));
#endif
#ifdef PEGASUS
	ex_db.ex_ini = 1;
#else
	ex_db.ex_init = 1;
#endif
	return 1;
}

unsigned SEGNO(x)
	long x;
{
	struct host_long xx;

	xx.l = x;
	return( (unsigned)(xx.sl.s_high << 12) );
}
